Program Aniwemva_dottest

	use sep

	! Aniso modules
	use ani_type
	use ani_parms_cg
	use ani_exec_time
	use ani_taper
	use ani_wemvacg_rand

	! Lloyd referene model building
	use lloyd_model

implicit none

	real													:: start,finish,start1,finish1
	real, allocatable										:: refr(:,:,:), taper(:)
	real, allocatable                                     :: model(:,:,:)
	complex, allocatable       					     	:: source1(:)
	double precision, dimension(2)									:: dotrst
	integer												:: sh_position, iter
	integer                                               :: iz, ix, isecdim, isdso
	double precision                                      :: err, funt
	real                                                  :: lamda, lam_min, factor, tola
	real                                                  :: p_hi(2), p_lo(2)
	integer, allocatable                                  :: nstart(:)

	real,allocatable                                      :: data1(:,:,:), data2(:,:,:)
	real,allocatable										:: modl1(:,:,:), modl2(:,:,:)

	call sep_init()

	write(0,*) "---------------------------------------------------------------"
	write(0,*) "                    Initialization                             "
	write(0,*) "---------------------------------------------------------------"

	call aniparam()

	allocate(data1(img%xm%n,nsecdim,img%z%n),  data2(img%xm%n,nsecdim,img%z%n) )
	allocate(modl1(nx,nz,npar_inv), modl2(nx,nz,npar_inv))

	call random_number(modl1)
	call random_number(data2)
	modl1 = modl1 / 3000.
	data2 = data2 / 100.

	modl2 = 0.; data1 = 0.; dot = 0.;

	call aniexec_time(start)

	! Backgournd model, in velocity 
	allocate(model(nx,nz,npar_in))
	call sreed("mdl", model, 4*nx*nz*npar_in)
	where(model(:,:,2)<1e-6) model(:,:,2) = 0.
	where(model(:,:,3)<1e-6) model(:,:,3) = 0.
	write(0,*) "initial velocity ", maxval(model(:,:,1)), minval(model(:,:,1))
	write(0,*) "initial eta ",   maxval(model(:,:,2)), minval(model(:,:,2))
	if (npar_in==3) write(0,*) " exist delta ",   maxval(model(:,:,3)), minval(model(:,:,3))

	! nstart
	allocate(nstart(npar_in))
	call from_param("nstart", nstart)

	! Convert everything to slowness
	model(:,:,1) =  1./model(:,:,1)   ! slowness; eta
	write(0,*) "after conver to slowness", maxval(model(:,:,1)), minval(model(:,:,1))

	! Reference model space
	allocate(refr(nref_max,nz,npar_in))

	! Source wavelet
	allocate(source1(sou%w%n)); call sreed("sou", source1, 8*sou%w%n)

	! Taper
	allocate(taper(nx)); call anitaper(tapertr,taper)

	call aniexec_time(finish)
	write(0,'(8x,a,f10.2,a)')' Init.phase - Total elapsed time:', (finish - start),' (sec)'
	! ---------------------------------------------------------------

	! ---------------------------------------------------------------
	! The main loop
	! ---------------------------------------------------------------

	refr = 0.; call lloydmodel(scales, nstart, model, refr)
    call aniwemva_init(source1, taper, model, refr)
	call aniwei_init(1)
	call aniexec_time(start)
    call aniwemva_lop2(.false., .false., modl1, data1)
	call aniexec_time(finish)
	write(0,'(8x,a,f10.2,a)')' Forward for eta:', (finish - start)/60,' (min)'


    call aniwemva_init(source1, taper, model, refr)
	call aniwei_init(1)
	call aniexec_time(start)
    call aniwemva_lop2(.true. , .false., modl2, data2)
	call aniexec_time(finish)
	write(0,'(8x,a,f10.2,a)')' Forward for eta:', (finish - start)/60,' (min)'

	dotrst(1) = sum(dprod(data1,data2))
	dotrst(2) = sum(dprod(modl1,modl2))

    write(0,*) "Dot test result"
    write(0,*) "===================================="
    write(0,*) dotrst
    write(0,*) "===================================="
    write(0,*) ""
    write(0,*) ""
    write(0,*) ""
    write(0,*) ""

	deallocate(model, modl1, modl2, data1, data2)
	deallocate(source1, taper, refr)
	call sep_close()
	
end Program Aniwemva_dottest

