Program Aniwemva_hessian

	use sep

	! Aniso modules
	use ani_type
	use ani_parms_cg
	use ani_exec_time
	use ani_taper
	use ani_wemvacg2

	! Lloyd referene model building
	use lloyd_model

implicit none

	real													:: start,finish,start1,finish1
	real, allocatable										:: refr(:,:,:), taper(:)
	real, allocatable                                     :: model(:,:,:)
	complex, allocatable       					     	:: source1(:)
	integer												:: sh_position, iter
	integer                                               :: iz, ix, isecdim, isdso
	double precision                                      :: err, funt
	real                                                  :: lamda, lam_min, factor, tola
	real                                                  :: p_hi(2), p_lo(2)
	integer, allocatable                                  :: nstart(:)

	real,allocatable                                      :: data1(:,:,:)
	real,allocatable										:: modl1(:,:,:), modl2(:,:,:)

	call sep_init()

	write(0,*) "---------------------------------------------------------------"
	write(0,*) "                    Initialization                             "
	write(0,*) "---------------------------------------------------------------"

	call aniparam()

	allocate(data1(img%xm%n,nsecdim,img%z%n) )
	allocate(modl1(nx,nz,npar_inv), modl2(nx,nz,npar_inv))

	modl1(:,:,1) = 3000.; 
	modl1(:,:,2) = 0.; 

	modl2 = 0.; data1 = 0.; 

	call aniexec_time(start)

	! Backgournd model, in velocity 
	allocate(model(nx,nz,npar_in))
	call sreed("mdl", model, 4*nx*nz*npar_in)
	where(model(:,:,2)<1e-6) model(:,:,2) = 0.
	where(model(:,:,3)<1e-6) model(:,:,3) = 0.
	write(0,*) "initial velocity ", maxval(model(:,:,1)), minval(model(:,:,1))
	write(0,*) "initial eta ",   maxval(model(:,:,2)), minval(model(:,:,2))
	if (npar_in==3) write(0,*) " exist delta ",   maxval(model(:,:,3)), minval(model(:,:,3))

	! nstart
	allocate(nstart(npar_in))
	call from_param("nstart", nstart)

	! Convert everything to slowness
	model(:,:,1) =  1./model(:,:,1)   ! slowness; eta
	write(0,*) "after conver to slowness", maxval(model(:,:,1)), minval(model(:,:,1))

	! Reference model space
	allocate(refr(nref_max,nz,npar_in))

	! Source wavelet
	allocate(source1(sou%w%n)); call sreed("sou", source1, 8*sou%w%n)

	! Taper
	allocate(taper(nx)); call anitaper(tapertr,taper)

	call aniexec_time(finish)
	write(0,'(8x,a,f10.2,a)')' Init.phase - Total elapsed time:', (finish - start),' (sec)'
	! ---------------------------------------------------------------

	! ---------------------------------------------------------------
	! The main loop
	! ---------------------------------------------------------------

	refr = 0.; call lloydmodel(scales, nstart, model, refr)
    call aniwemva_init(source1, taper, model, refr)
	call aniwei_init()


	call aniexec_time(start)
    call aniwemva_lop2(.false., .false., modl1, data1)
	call aniexec_time(finish)
	write(0,'(8x,a,f10.2,a)')' Forward for slowness:', (finish - start)/60,' (min)'

	call srite("dimage",data1, 4*img%xm%n*nsecdim*img%z%n)

	call aniexec_time(start)
    call aniwemva_lop2(.true. , .false., modl1, data1)
	call aniexec_time(finish)
	write(0,'(8x,a,f10.2,a)')' Adjoint for slowness:', (finish - start)/60,' (min)'
	modl2(:,:,1) = modl1(:,:,1);


	modl1(:,:,1) = 0.;
	modl1(:,:,2) = 0.05;



	call aniexec_time(start)
    call aniwemva_lop2(.false., .false., modl1, data1)
	call aniexec_time(finish)
	write(0,'(8x,a,f10.2,a)')' Forward for eta:', (finish - start),' (sec)'

	call srite("dimage",data1, 4*img%xm%n*nsecdim*img%z%n)

	call aniexec_time(start)
    call aniwemva_lop2(.true. , .false., modl1, data1)
	call aniexec_time(finish)
	write(0,'(8x,a,f10.2,a)')' Adjoint for eta:', (finish - start),' (sec)'
	modl2(:,:,2) = modl1(:,:,2);

	call srite("out", modl2, 4*nx*npar_inv*nz)

	deallocate(model, modl1, modl2, data1)
	deallocate(source1, taper, refr)
	call sep_close()
	
end Program Aniwemva_hessian

