program InitVelBuild 

  use sep

  implicit none

  integer                                :: n1, n2
  real                                   :: o1, o2, d1, d2
  integer                                :: i, j, k, z_seabed
  real,allocatable                       :: vel(:,:)
  real,allocatable                       :: initvel(:,:,:), mask(:,:,:)
  real                                   :: f1, f2, vmax, vmin, vwater, minv_sed, beta, vmin_eta

  call initpar()
  call from_history("n1", n1)
  call from_history("n2", n2)
  call from_history("o1", o1)
  call from_history("o2", o2)
  call from_history("d1", d1)
  call from_history("d2", d2)
  call from_param("vmax", vmax, 3000.)          ! .. max sediment velocity
  call from_param("vwater", vwater, 1524.)      ! .. water velocity
  call from_param("minv_sed", minv_sed, 1600.)  ! .. min sediment velocity
  call from_param("beta", beta, 0.)             ! .. background eta
  call from_param("vmin_eta", vmin_eta, 2000.)  ! .. min velocity that posibly has anisotropy



  allocate(vel(n1,n2),initvel(n1,n2,2), mask(n1,n2,2))
  write(0,*) n1, n2

  call sep_read(vel)


  initvel=0.
  mask=1.

  ! mask for velocity down to the sea bottom
  where(vel<minv_sed)
    initvel(:,:,1)=1560
    mask(:,:,1)=0.
  end where

  ! mask for eta, down to the vmin_eta
  where(vel<vmin_eta)
    mask(:,:,2) = 0.
  end where

  do j=1,n2
    do k = 1,n1-1
      if(initvel(k,j,1)==1560 .and. initvel(k+1,j,1)==0.) then 
        z_seabed = k+1
        exit
      end if
    end do
    do k = z_seabed,n1
!      if (k<z_seabed+2) then
!        mask(k,j) = 0.
!      end if
      initvel(k,j,1) = (vmax-minv_sed)/(n1-z_seabed+1)*(k-z_seabed+1) + minv_sed
      initvel(k,j,2) = beta
    end do
  end do


  call sep_write(initvel)
  call srite("mask", mask, 4*n1*n2*2)

  call to_history("n1", n1)
  call to_history("n2", n2)
  call to_history("n3",  2)
  call to_history("d1", d1)
  call to_history("d2", d2)
  call to_history("d3", 1.)
  call to_history("o1", o1)
  call to_history("o2", o2)
  call to_history("o3", 0.)
  call to_history("esize", 4)

  call to_history("n1", n1, "mask")
  call to_history("n2", n2, "mask")
  call to_history("n3",  2, "mask")
  call to_history("d1", d1, "mask")
  call to_history("d2", d2, "mask")
  call to_history("o1", o1, "mask")
  call to_history("o2", o2, "mask")
  call to_history("esize", 4, "mask")

  deallocate(vel,initvel,mask)
end program  
