program StrchNMOvel 

  use sep

  implicit none

  integer                                :: n1, n2
  real                                   :: o1, o2, d1, d2
  integer                                :: i, j, k 
  real,allocatable                       :: vel(:,:), dzfield(:,:)
  real,allocatable                       :: dlt(:,:), strvel(:,:)
  real                                   :: z, f1, f2

  call initpar()
  call from_history("n1", n1 )
  call from_history("n2", n2)
  call from_history("o1", o1)
  call from_history("o2", o2)
  call from_history("d1", d1)
  call from_history("d2", d2)

  allocate(vel(n1,n2),dzfield(n1,n2),strvel(n1,n2),dlt(n1,n2))
  write(0,*) n1, n2

  call sep_read(vel)
  call sreed("dlt", dlt, 4*n1*n2)

  write(0,*) "after read"

  do i=2,n1
    do j = 1, n2
      dzfield(i,j) = d1 * sqrt(1+2*dlt(i-1,j))
    end do
  end do

  do i=2,n1
    ! depth on the streched grid
    dzfield(i,:) = dzfield(i,:) + dzfield(i-1,:)
  end do

  write(0,*) dzfield(1,1)
  do j=1,n2
    do i=1,n1
      ! depth on the regular grid
      z = (i-1)*d1+o1
      do k = 1,n1-1
        if(z>=dzfield(k,j) .and. z<dzfield(k+1,j)) then 
          f1 = (z-dzfield(k,j)) / (dzfield(k+1,j)-dzfield(k,j))
          f2 = 1.0-f1
          strvel(i,j) = f1 * vel(k,j) + f2 * vel(k+1,j)
          exit
        end if
      end do
    end do
  end do

  strvel = strvel + 36.

  call sep_write(strvel)
  call to_history("n1", n1)
  call to_history("n2", n2)
  call to_history("n3", 1 )
  call to_history("o3", 1 )
  call to_history("d3", 1 )
  call to_history("d1", d1)
  call to_history("d2", d2)
  call to_history("o1", o1)
  call to_history("o2", o2)
  call to_history("esize", 4)

  deallocate(vel,strvel,dzfield,dlt)
end program StrchNMOvel 
