Program TestSpln

  use sep
  use base_spline_mod
  use ani_parms_cg

  implicit none

  real, allocatable					:: refr(:,:,:), taper(:), model_in(:,:,:)
  double precision, allocatable                         :: nmodel(:), model(:)
  integer :: stat, stat1, stat2

  call sep_init()
  call aniparam()

  allocate(nmodel(axk_v%n*azk_v%n), model_in(nx, nz, npar_inv)) 
  allocate(model(nx*nz))
  call sreed("mdl", model_in, 4*nx*nz*npar_inv)
  model = reshape(model_in(:,:,1),(/nx*nz/))
  write(0,*) maxval(model), minval(model)

  stat = base_spln2d_init(mdl%z, mdl%xm, azk_v, axk_v)
  stat1 = base_spln2d_oper(.true. , .false., nmodel, model)     
  write(0,*) maxval(nmodel), minval(nmodel)
  stat2 = base_spln2d_oper(.false. ,.false., nmodel, model)
  write(0,*) maxval(model), minval(model)


  call to_history("n1",nx)
  call to_history("n2",nz)
  call to_history("n3",1)
  call srite("out",sngl(model),4*nx*nz)
  deallocate(nmodel,model,model_in)
end program


