Program Test_precond 

	use sep

	! Aniso modules
	use ani_type
	use ani_parms_cg
	use ani_exec_time
	use ani_taper
	use ani_wemvacg2

	! Lloyd referene model building
	use lloyd_model

implicit none

	real													:: start,finish,start1,finish1
	real, allocatable										:: refr(:,:,:), taper(:)
	real, allocatable                                     :: model(:,:,:)
	complex, allocatable       					     	:: source1(:)
	real, dimension(2)									:: dotrst
	integer												:: sh_position, iter
	integer                                               :: iz, ix, isecdim, isdso
	double precision                                      :: err, funt
	real                                                  :: lamda, lam_min, factor, tola
	real                                                  :: p_hi(2), p_lo(2)
	integer, allocatable                                  :: nstart(:)

	real,allocatable                                      :: data1(:,:,:)
	real,allocatable										:: grad(:,:,:), hessian(:,:,:)

	call sep_init()

	write(0,*) "---------------------------------------------------------------"
	write(0,*) "                    Initialization                             "
	write(0,*) "---------------------------------------------------------------"

	call aniparam()

	allocate(grad(nx,nz,npar_inv), hessian(nx,nz,npar_inv))

	call aniexec_time(start)

	call sreed("grad_in", grad,    4*nx*nz*npar_inv)
	call sreed("hessian", hessian, 4*nx*nz*npar_inv)

	where(hessian(:,:,1).le.2e-7) grad(:,:,1) = 0.
	where(hessian(:,:,1).gt.2e-7) grad(:,:,1) = grad(:,:,1) / hessian(:,:,1)

	where(hessian(:,:,2).le.1e-4) grad(:,:,2) = 0.
	where(hessian(:,:,2).gt.1e-4) grad(:,:,2) = grad(:,:,2) / hessian(:,:,2)

	write(0,'(8x,a,f10.2,a)')' Init.phase - Total elapsed time:', (finish - start),' (sec)'
	! ---------------------------------------------------------------

	call srite("out", grad, 4*nx*npar_inv*nz)

	deallocate(grad,hessian)
	call sep_close()
	
end Program Test_precond 

