Program Test_steer 

  use sep

  ! Aniso modules
  use ani_type
  use ani_parms_cg
  use ani_smthgrd

  implicit none

  real						        					:: start,finish,start1,finish1
  real, allocatable										:: refr(:,:,:), taper(:)
  real, allocatable                                     :: dmodel(:), temp_model(:,:,:), nmodel(:,:,:), model(:,:,:)
  real, allocatable                                     :: B_image(:,:,:), D_image(:,:,:), t_image(:,:,:)
  complex, allocatable       			     			:: source1(:)
  integer					       						:: sh_position, iter
  integer                                               :: iz, ix, isecdim, isdso
  real, allocatable                                     :: l(:,:,:), u(:,:,:)
  double precision, allocatable                         :: fun(:)
  double precision                                      :: err, funt
  real                                                  :: lamda, lam_min, factor, tola
  real                                                  :: p_hi(2), p_lo(2)
  integer, allocatable                                  :: nstart(:)


  call sep_init()

  call aniparam()

  write(0,*) "---------------------------------------------------------------"
  write(0,*) "                    Initialization                             "
  write(0,*) "---------------------------------------------------------------"

  allocate(dmodel(nx*nz*2))		
  call sreed("field",dmodel,4*nx*nz*2)

  call smoothgrd_init(1)
  
  select case (grdsm_style) 
  case("spln")
	call smoothgrd_spln(dmodel)
  case("tria")	
    call smoothgrd_tria(dmodel)
  case('ster')	
    call smoothgrd_ster(dmodel)
    dmodel = dmodel*mute
	call smoothgrd_tria(dmodel)
  end select	
  write(0,*) "after smoothing"


  call sep_write(dmodel)

  deallocate(dmodel)

  call sep_close()
end Program 

