program InitVelBuild 

  use sep

  implicit none

  integer                                :: n1, n2
  real                                   :: o1, o2, d1, d2
  integer                                :: i, j, k, z_seabed
  real,allocatable                       :: vel(:,:)
  real,allocatable                       :: initvel(:,:)
  real                                   :: f1, f2, vmax, vmin, vwater, minv_sed, beta, vmin_eta

  call initpar()
  call from_history("n1", n1)
  call from_history("n2", n2)
  call from_history("o1", o1)
  call from_history("o2", o2)
  call from_history("d1", d1)
  call from_history("d2", d2)
  call from_param("vmax", vmax, 3000.)          ! .. max sediment velocity
  call from_param("vwater", vwater, 1524.)      ! .. water velocity
  call from_param("minv_sed", minv_sed, 1600.)  ! .. min sediment velocity
  call from_param("beta", beta, 0.)             ! .. background eta
  call from_param("vmin_eta", vmin_eta, 2050.)  ! .. min velocity that posibly has anisotropy



  allocate(vel(n1,n2),initvel(n1,n2))
  write(0,*) n1, n2

  call sep_read(vel)


  initvel=vel

  ! mask for velocity down to the sea bottom
  where(vel<minv_sed)
    initvel=1560
  end where

!  where( abs(vel-1651.) < 1. )
!    initvel = 1675 
!  end where

!  where( abs(vel-1943.) < 1.)
!    initvel = 2040 
!  end where

!  where( abs(vel-2122.) < 1.)
!    initvel = 2300 
!  end where

  call sep_write(initvel)

  call to_history("n1", n1)
  call to_history("n2", n2)
  call to_history("d1", d1)
  call to_history("d2", d2)
  call to_history("o1", o1)
  call to_history("o2", o2)
  call to_history("esize", 4)

  deallocate(vel,initvel)
end program  
