program Work 

  use sep

  implicit none

  integer                                :: n1, n2, n3
  real                                   :: o1, o2, d1, d2
  integer                                :: i, j, k, z_seabed
  real,allocatable                       :: vel(:,:), eta(:,:)
  real,allocatable                       :: grad(:,:,:,:), initvel(:,:)

  call initpar()
  call from_history("n1", n1)
  call from_history("n2", n2)
  call from_history("n3", n3)
  call from_history("n4", n4)
  call from_history("o1", o1)
  call from_history("o2", o2)
  call from_history("d1", d1)
  call from_history("d2", d2)
  call from_param("vmax", vmax, 3000.)
  call from_param("vwater", vwater, 1524.)
  call from_param("minv_sed", minv_sed, 1600.)
  call from_param("beta", beta, 0.)



  allocate(vel(n1,n2), eta(n1,n2) ,grad(n1,n2,n3,n4), initvel(n1,n2,2))

  vel = 0.; eta = 0.
  call sep_read(grad)
  call sreed("initvel",initvel,4*n1*n2*2)

  do i = 1:n4
    vel = vel + grad(:,:,1,i) * 0.5
    eta = eta + grad(:,:,2,i) * 0.5
  end do

  where (eta < 0.) 
    eta = 0.
  end where
  
  

  call sep_write(vel)
  call srite("eta", eta, 4*n1*n2)

  call to_history("n1", n1)
  call to_history("n2", n2)
  call to_history("n3",  2)
  call to_history("d1", d1)
  call to_history("d2", d2)
  call to_history("o1", o1)
  call to_history("o2", o2)
  call to_history("esize", 4)

  call to_history("n1", n1, "mask")
  call to_history("n2", n2, "mask")
  call to_history("d1", d1, "mask")
  call to_history("d2", d2, "mask")
  call to_history("o1", o1, "mask")
  call to_history("o2", o2, "mask")
  call to_history("esize", 4, "mask")

  deallocate(vel,initvel,mask)
end program  
