program adcigs

  use sep

  implicit none

    integer                               :: idepth, icmp, iangle, ncig=16
    real, allocatable                     :: cigcube(:,:,:), cigplane(:,:)
    integer                               :: n1out, n2out
    real                                  :: d1, o1, d2, o2, d3, o3
    integer                               :: n1, n2, n3, tmp_begin, tmp_end
    character(20)                         :: label1, label2


    call sep_init(SOURCE)
    
    ! Get data dimensions from command line.
    call from_aux("data","n1",n1)	           
    call from_aux("data","n2",n2)
    call from_aux("data","n3",n3)
    call from_aux("data","label1",label1)
    call from_aux("data","label2",label2)
    ! Get data subscript from command line
    call from_aux("data","o1",o1)
    call from_aux("data","o2",o2)
    call from_aux("data","o3",o3)
    call from_aux("data","d1",d1)
    call from_aux("data","d2",d2)
    call from_aux("data","d3",d3)

    n1out = n1
    n2out = ncig * n3
    allocate(cigcube(n1, n2, n3),cigplane(n1out, n2out))
    call sreed('data', cigcube, 4*n1*n2*n3)

    call to_history("n1",n1)             
      call to_history("n2",n2out)
      call to_history("o1",o1)
      call to_history("o2",o3)
      call to_history("d1",d1)
      call to_history("d2",d3)
      call to_history("esize", 4)
      call to_history("label1",label1)

    iangle = 0
    do icmp = 200, n2
	if (mod(icmp, ncig)==1) then
            tmp_begin = (iangle ) * n3 + 1
	    tmp_end   = (iangle + 1) * n3
	    cigplane(:,tmp_begin:tmp_end) = cigcube(:,icmp+ncig,:)
            iangle = iangle + 1
	end if
        if (iangle==ncig) exit
    end do

    call sep_write(cigplane)
    deallocate(cigcube, cigplane)

end program adcigs


