module ani_dso2
  use ani_parms_cg
  contains

  subroutine anidso(wgcig,mdso,illum)

    real                                            :: wgcig(:,:,:),h
    real,optional                                   :: illum(:,:,:)
    real,allocatable                                :: ogcig(:,:,:),wm(:),wd(:)
    integer                                         :: ix,isecdim,iz,mdso
    real                                            :: thred, wm_avg, wd_avg

    allocate(ogcig(nx,nsecdim,nz));	ogcig = 0.
    if (mdso==3) then
      allocate(wm(nx), wd(nx))
      wm = 0.; wd=0.
    end if
    call from_param("dso_thred", thred, 0.)

    do isecdim=1,nsecdim
      h=(isecdim-1)*dsecdim+osecdim + dsecdim
      if (h <= thred .and. h >= -thred) then
        ogcig(:,isecdim,:) = 0.
      else
        select case (mdso)
        case(0)
          h=abs(h)/((nsecdim-1)*dsecdim+osecdim)
          ogcig(:,isecdim,:)=wgcig(:,isecdim,:)*h*h
          if (present(illum)) then
            ogcig = ogcig / illum
          end if
        case(1)
		  if (isecdim .ge. 2 .and. isecdim .le.nsecdim-1) then
			ogcig(:,isecdim,:) = (wgcig(:,isecdim-1,:) - 2*wgcig(:,isecdim,:) + wgcig(:,isecdim+1,:)) / (dsecdim**2)
		  end if
          if (present(illum)) then
            ogcig = ogcig / illum
          end if
        case(2)
		  if (isecdim .ge. 2 .and. isecdim .le.nsecdim-1) then
			ogcig(:,isecdim,:) = (wgcig(:,isecdim-1,:) - 2*wgcig(:,isecdim,:) + wgcig(:,isecdim+1,:)) / (dsecdim**2)
		  end if
          ogcig(:,isecdim,:)=ogcig(:,isecdim,:)*h*h
          if (present(illum)) then
            ogcig = ogcig / illum
          end if
        case(3)
          h=abs(h)/((nsecdim-1)*dsecdim+osecdim)
          do iz=1,nz
            wm = wm + wgcig(:,isecdim,iz)*wgcig(:,isecdim,iz)
            wd = wd + h*h*wgcig(:,isecdim,iz)*wgcig(:,isecdim,iz)
          end do
        end select
        end if
      end do

      if (mdso==3) then
        wm_avg = sum(wm)/nx
        where(wm<wm_avg)
          wm = wm_avg
        end where
        do isecdim=1,nsecdim
          h=(isecdim-1)*dsecdim+osecdim + dsecdim
          h=abs(h)/((nsecdim-1)*dsecdim+osecdim)
          do iz = 1,nz
            ogcig(:,isecdim,iz) = h*h*wgcig(:,isecdim,iz)*wm - wgcig(:,isecdim,iz)*wd
            ogcig(:,isecdim,iz) = ogcig(:,isecdim,iz) / wm / wm
          end do
        end do
      end if


      wgcig=ogcig
      deallocate(ogcig)
    end subroutine anidso

  end module ani_dso2
