module ani_image_deci
  !
  ! Imaging Condition -- crosscorrelation
  !

  use ani_type
  use ani_parms_cg

  implicit none

  contains
  !=====================================================================================
  subroutine aniimage(adj,iw,ws,wr,image,ssou,sillu)
    logical					:: adj
    logical, optional                           :: ssou
    integer					:: isecdim, ihso, ith, ixw,iw,sign
    integer					:: ixm 
    complex					:: wr(:),ws(:)
    real, optional                              :: sillu(:,:)
    real					:: image(:,:)

    if (adj) then
      do isecdim=1,nsecdim
        ihso=nint(((isecdim-1)*dsecdim+osecdim)/dx) 
        do ixm=1,img%xm%n  ! image x index
			ixw = nint(((ixm-1)*img%xm%d + img%xm%o - ox)/dx ) + 1 ! wavefield x index
          	if (ixw-ihso >= 1 .and. ixw-ihso <= nx .and. ixw+ihso >= 1 .and. ixw+ihso <= nx) then
            	if (ssou) then
              		ws(ixw-ihso)=ws(ixw-ihso)+wr(ixw+ihso)*image(ixm,isecdim)
            	else
              		wr(ixw+ihso)=wr(ixw+ihso)+ws(ixw-ihso)*image(ixm,isecdim)
            	end if
          	end if
        end do
      end do
    else
      do isecdim=1,nsecdim
        ihso=nint(((isecdim-1)*dsecdim+osecdim)/dx) 
        do ixm=1,img%xm%n  ! image x index
			ixw = nint(((ixm-1)*img%xm%d + img%xm%o - ox)/dx) + 1 ! wavefield x index
        	if (ixw-ihso >= 1 .and. ixw-ihso <= nx .and. ixw+ihso >= 1 .and. ixw+ihso <= nx) then
            	image(ixm,isecdim)=image(ixm,isecdim)+conjg(ws(ixw-ihso))*wr(ixw+ihso)
        	end if
        end do
      end do
    end if
  end subroutine
end module
