module ani_image
  !
  ! Imaging Condition -- crosscorrelation
  !

  use ani_type
  use ani_parms_cg

  implicit none

  contains
  !=====================================================================================
  subroutine aniimage(adj,iw,ws,wr,image,ssou,sillu)
    logical					:: adj
    logical, optional                           :: ssou
    integer					:: isecdim, ihso, ith, ixw,iw,sign
    complex					:: wr(:),ws(:)
    real, optional                              :: sillu(:,:)
    real					:: image(:,:),hto

    if (adj) then
      do isecdim=1,nsecdim
        ihso=nint(((isecdim-1)*dsecdim+osecdim)/dx) 
        do ixw=1,kxm%n
          if (ixw-ihso >= 1 .and. ixw-ihso <= kxm%n .and. ixw+ihso >= 1 .and. ixw+ihso <= kxm%n) then
            if (ssou) then
              ws(ixw-ihso)=ws(ixw-ihso)+wr(ixw+ihso)*image(ixw,isecdim)
            else
              wr(ixw+ihso)=wr(ixw+ihso)+ws(ixw-ihso)*image(ixw,isecdim)
            end if
          end if
        end do
      end do
    else
      do isecdim=1,nsecdim
        ihso=nint(((isecdim-1)*dsecdim+osecdim)/dx) 
        do ixw=1,kxm%n
          if (ixw-ihso >= 1 .and. ixw-ihso <= kxm%n .and. ixw+ihso >= 1 .and. ixw+ihso <= kxm%n) then
            image(ixw,isecdim)=image(ixw,isecdim)+conjg(ws(ixw-ihso))*wr(ixw+ihso)
            ! Source side illumination
            if (present(sillu)) then
              sillu(ixw,isecdim) = sillu(ixw,isecdim) + conjg(ws(ixw-ihso))*ws(ixw-ihso)
            end if
          end if
        end do
        !write(0,*) "ihso", ihso, "isecdim", isecdim,"image", sum(abs(image(:,isecdim)))
      end do
    end if
  end subroutine
end module
