module ani_type

  public 						:: axis, dat_grid, img_grid, mdl_grid, ref_grid
  !--------------------------------------------------
  !!.. define type for axes
  type axis 
     integer 					:: n		! total number
     real    					:: d		! spacing
     real    					:: o		! origin
     real, allocatable				:: all(:)  	! values
  end type axis

  !---------------------------------------------------
  !!.. define data grid
  type dat_grid
     type(axis) :: w, h, xd
	 integer					:: iosize	! input output size
  end type dat_grid

  !---------------------------------------------------
  !!.. define image grid
  type img_grid
     type(axis) :: z, sh, xm, ym, th
	 integer					:: iosize	! input output size
  end type img_grid

  !---------------------------------------------------
  !!.. define model grid
  !!... eps and delta have the same structure
  type mdl_grid
     type(axis) :: z, xm, ym, par
	 integer					:: iosize	! input output size
  end type mdl_grid

  !----------------------------------------------------
  !!.. define reference model grid
  !!... eps and delta have the same structure
  type ref_grid
     type(axis) :: z, rf, par
  end type ref_grid

end module ani_type
