module lloyd_model

  use sep3d_struct_mod
  use lloyd_mod
  use sep
  use ani_parms_cg

  implicit none

  contains

  subroutine lloydmodel(scales, nstart, model, lloyd)
    real                      :: scales(:), model(:,:,:), lloyd(:,:,:) 
    integer, allocatable      :: iregion(:)
    integer                   :: iref, iz, ntotal, ipar, nstart(:)
    real, allocatable         :: slice(:,:)

    allocate(iregion(nx), slice(nx, npar_in))

    call init_lloyd()
    ntotal = 0
    do iz = 1, nz
      slice(:,:) = model(:,iz,:)
      do ipar = 1, npar_in
        slice(:,ipar) = slice(:,ipar) * scales(ipar)
      end do
      iref = lloyd_go(slice, lloyd(:,iz,:), nref_max, iregion, nstart)
      ntotal = ntotal + iref
      do ipar = 1, npar_in
        lloyd(:,iz,ipar) = lloyd(:,iz,ipar) / scales(ipar)
      end do
    end do


    deallocate(iregion, slice)
  end subroutine lloydmodel
end module lloyd_model
