Program velbuild

  use sep
  
  implicit none

  ! Axis parameters
  integer                             :: n1, n2, n3
  real                                :: o1, d1, o2, d2, o3, d3

  ! Axis parameter for slowness perturbation
  integer                             :: do1, do3, dl1, dl3

  ! Looping index
  integer                             :: i1, i3

  ! Slowness parameters
  ! Slowness and slowness perturbation value
  real                                :: bs, ds
  ! Slowness fields
  real, allocatable                   :: bsf(:,:,:), dsf(:,:,:)
  logical                             :: iseta

  call sep_init()


  ! unit: s/km
  call from_param("ds", ds, 0.333e-5)
  call from_param("iseta", iseta, .false.)
  

  call from_param("nz", n1, 201)
  call from_param("nx", n3, 501)
  call from_param("do1", do3, 300)
  call from_param("do3", do1, 16)
  call from_param("dl1", dl3, 20)
  call from_param("dl3", dl1, 30)
  

  ! unit: m
  call from_param("ox", o1, 0.)
  call from_param("oz", o3, -2500.)
  call from_param("dx", d1, 10.)
  call from_param("dz", d3, 10.)
  
  n2 = 1; d2 = 0; o2 = 0;

  call to_history("n1", n1); call to_history("o1", o1); call to_history("d1", d1); 
  call to_history("n2", n2); call to_history("o2", o2); call to_history("d2", d2); 
  call to_history("n3", n3); call to_history("o3", o3); call to_history("d3", d3); 

  call to_history("n1", n1, "deltaS"); call to_history("o1", o1, "deltaS"); call to_history("d1", d1, "deltaS"); 
  call to_history("n2", n2, "deltaS"); call to_history("o2", o2, "deltaS"); call to_history("d2", d2, "deltaS"); 
  call to_history("n3", n3, "deltaS"); call to_history("o3", o3, "deltaS"); call to_history("d3", d3, "deltaS"); 


  bs = 0.

  allocate(bsf(n1,n2,n3),dsf(n1,n2,n3))
  
  do i3 = 1, n3
     do i1 = 1, n1 
        bsf(i1, 1, i3) = bs
        dsf(i1, 1, i3) = bs
     end do
  end do
  if (.not. iseta) then
     do i3 = do3, do3+dl3
        do i1 = do1, do1+dl1
           dsf(i1, 1, i3) = ds
        end do
     end do
  else
     do i3 = do3, do3+dl3
        do i1 = do1, do1+dl1
           dsf(i1, 1, i3) = -ds*300
        end do
     end do
  end if


  call sep_write(bsf)
  call sep_write(dsf, "deltaS")

  deallocate(bsf, dsf)

end program velbuild
